#include "ab.h"

#define DATA     "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define LENGTH   7

int received = 0, sent = 0;
unsigned short error = 0;

unsigned char memcmp(const char * s1, const char * s2, short l) {
  while(*(s1++) == *(s2++) && l--);
  return l==-1; 
}

void ph(const unsigned char * msg, unsigned char l) {
  if (!msg) {
  	error = 1;
  } else if (l != LENGTH) {
  	error = 2;
  } else if (memcmp(msg, DATA, LENGTH)) {
  	error = 3;
  } else {
  	received++;
  }
}

int main() {
  if (init_ab_protocol_8(ph, 2)) {
    cputs ("ERR");
  } else {
    while (!error) {
      cputw((((unsigned char)received) << 8) + sent);
      if(ab_swrite(DATA, LENGTH, 1)) error = 4;
      else sent++;
    }
  }
  cputw(error);
 
  return 0;
}
